Set instance configuration
- PUT /platform/configuration/instances/{id}
Creates or updates an instance configuration.
Path Parameters
-
idstringrequired -
ID of the instance configuration
Query Parameters
-
versioninteger This is a database-level field, not related to the application-level 'config_version', except as described in the following docs. If specified, checks for conflicts against 'x-cloud-resource-version' from the GET request (where the 'config_version' in the GET should match the the 'configuration_version' in the PUT body if the IC is configuration controlled).
-
config_controlboolean If true, then an update that changes immutable fields will create a new version of the IC (leaving the previous ones accessible via 'config_version'). Otherwise such updates will fail.
-
test_configboolean If true, The IC is added as a test version (set 'instance_config_version': -1 in the deployment request to reference), leaving the existing IC alone. Will error if the IC doesn't already exist.
-
strict_modeboolean If true, then allocator_filter and storage_multiplier cannot be changed in an existing IC. Defaults to false unless config_control is true (in which case a new version is created)
-
create_onlyboolean If true, will fail if an instance configuration already exists at the given id
Request
the Instance Configuration
-
idstring -
Unique identifier for the instance configuration
-
namestringrequired -
Display name for the instance configuration.
-
config_versioninteger -
If the IC is configuration controlled, this field is the version either being read back (reads return the latest IC unless specified by the 'config_version' URL param), or the version to update. Cannot be used in creates. For unversioned IC reads it is left empty.
-
descriptionstring -
Optional description for the instance configuration
-
instance_type -
The type of instance. For instance configurations where the type is specified in the 'id', the default value of 'instance_type' will be automatically inferred.
-
Values:
elasticsearchkibanaapmintegrations_serverappsearchenterprise_search -
node_typesstring -
Node types (master, data) for the instance. For instance configurations where the type (and tier) is specified in the 'id', the default value of 'node_types' will be automatically inferred.
-
discrete_sizesDiscreteSizesrequired -
Instance sizes that are supported by the Elasticsearch instance, Kibana instance, or APM Server configuration.
-
sizesintegerrequired -
List of supported sizes
-
default_sizeinteger -
The default size
-
resource -
The unit that each size represents. If not specified, it will default to 'memory'.
-
Values:
memorystorage -
allocator_filterQueryContainer -
The container for all of the allowed Elasticsearch queries. Specify only one property each time.
-
matchmap string to MatchQuery -
<string>MatchQuery -
querystringrequired -
The text/numeric/date to query for.
-
operatorstring -
The operator flag can be set to or or and to control the boolean clauses (defaults to or).
-
minimum_should_matchinteger -
The minimum number of optional should clauses to match.
-
analyzerstring -
The analyzer that will be used to perform the analysis process on the text. Defaults to the analyzer that was used to index the field.
-
match_allMatchAllQuery -
A query that matches all documents.
-
match_noneMatchNoneQuery -
A query that doesn't match any documents.
-
boolBoolQuery -
A query for documents that match boolean combinations of other queries.
-
mustQueryContainer -
shouldQueryContainer -
must_notQueryContainer -
filterQueryContainer -
minimum_should_matchinteger -
The minimum number of optional should clauses to match.
-
query_stringQueryStringQuery -
A query that uses the strict query string syntax for parsing. Will return an error for invalid syntax.
-
querystringrequired -
The actual query to be parsed.
-
default_fieldstring -
The default field for query terms if no prefix field is specified.
-
analyzerstring -
The analyzer used to analyze each term of the query when creating composite queries.
-
default_operatorstring -
The default operator used if no explicit operator is specified.
-
allow_leading_wildcardboolean -
When set, * or ? are allowed as the first character. Defaults to false.
-
nestedNestedQuery -
A query that matches nested objects.
-
queryQueryContainerrequired -
The container for all of the allowed Elasticsearch queries. Specify only one property each time.
-
pathstringrequired -
The path to the nested object.
-
score_mode -
Allows to specify how inner children matching affects score of the parent. Refer to the Elasticsearch documentation for details.
-
Values:
avgsumminmaxnone -
prefixmap string to PrefixQuery -
existsExistsQuery -
Matches documents that have at least one non-
nullvalue in the original field. -
fieldstringrequired -
The field to check for non-null values in.
-
rangemap string to RangeQuery -
<string>RangeQuery -
gtobject -
Greater-than
-
gteobject -
Greater-than or equal to
-
ltobject -
Less-than
-
lteobject -
Less-than or equal to.
-
boostnumber -
An optional boost value to apply to the query.
-
formatstring -
Formatted dates will be parsed using the format specified on the date field by default, but it can be overridden by passing the format parameter.
-
time_zonestring -
Dates can be converted from another timezone to UTC either by specifying the time zone in the date value itself (if the format accepts it), or it can be specified as the time_zone parameter.
-
simple_query_stringSimpleQueryStringQuery -
A query that uses simple query string syntax. Will ignore invalid syntax.
-
querystringrequired -
The query expressed in simple query string syntax.
-
fieldsstring -
Array of fields to search
-
default_operatorstring -
The boolean operator used to combine the terms of the query. Valid values are
OR(default) andAND. -
analyze_wildcardboolean -
If
true, the query attempts to analyze wildcard terms. Defaults tofalse. -
analyzerstring -
The name of the analyzer to use to convert the query text into tokens.
-
auto_generate_synonyms_phrase_queryboolean -
If
true, the parse creates amatch_phraseuery for each multi-position token. Defaults totrue. -
flagsstring -
List of enabled operators for the simple query string syntax. Defaults to
ALL. -
fuzzy_max_expansionsinteger -
Maximum number of terms to which the query expands for fuzzy matching. Defaults to 50.
-
fuzzy_prefix_lengthinteger -
Number of beginning characters left unchanged for fuzzy matching. Defaults to 0.
-
fuzzy_transpositionsboolean -
If
true, edits for fuzzy matching include transpositions of two adjacent characters. Defaults tofalse. -
lenientboolean -
If
true, format-based errors, such as providing a text value for a numeric field are ignored. Defaults tofalse. -
minimum_should_matchstring -
Minimum number of clauses that must match for a document to be returned.
-
quote_field_suffixstring -
Suffix appended to quoted text in the query string.
-
storage_multipliernumber -
Settings for the instance storage multiplier
-
deleted_onstring -
Date/time that this instance configuration was marked for deletion
-
system_ownedboolean -
Indicates if a instance configuration is system owned (restricts the set of operations that can be performed on it)
-
metadataobject -
Optional arbitrary metadata to associate with this template.
-
cpu_multipliernumber -
Settings for the instance CPU multiplier
-
allowed_zonesstring -
The zones this instance configuration may exist in. Leaving out this parameter or specifying an empty list implies all zones are allowed. Normally not needed, but can be useful for exceptional infrastructure constraints.
-
max_zonesinteger -
The maximum number of availability zones in which this instance configuration has allocators. This field will be missing unless explicitly requested with the show_max_zones parameter.
Responses
The instance configuration was updated successfully.
-
idstringrequired -
The ID
-
config_versionobject -
The version, if the entity is configuration controlled
-
config_version_updatedobject -
Returns true if the update resulted in a new version of the configuration controlled entity
The instance configuration was created successfully.
-
idstringrequired -
The ID
-
config_versionobject -
The version, if the entity is configuration controlled
-
config_version_updatedobject -
Returns true if the update resulted in a new version of the configuration controlled entity
cluster_type in the InstanceConfiguration model is invalid (code: 'configuration.invalid_cluster_type') or the ZooKeeper operation failed due to bad version, etc. (code: 'configuration.instance_configuration_update_failed') or the id in the InstanceConfiguration model is reserved/prohibited (code: 'configuration.configuration_id_reserved') or the discrete_sizes in the InstanceConfiguration model is invalid (code: 'configuration.invalid_discrete_sizes') or the metadata in the InstanceConfiguration model has empty keys or values (code: 'configuration.bad_meta_data')
-
errorsBasicFailedReplyElementrequired -
A list of errors that occurred in the failing request
system_owned or deleted_on cannot be set externally (code: 'configuration.system_owned')
-
errorsBasicFailedReplyElementrequired -
A list of errors that occurred in the failing request
Instance configuration specified by {id} cannot be found or the operation failed (code: 'configuration.instance_configuration_not_found')
-
errorsBasicFailedReplyElementrequired -
A list of errors that occurred in the failing request